/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
/******************************************************************************
 * MSP432 Empty Project
 *
 * Description: An empty project that uses DriverLib
 *
 *                MSP432P401
 *             ------------------
 *         /|\|                  |
 *          | |                  |
 *          --|RST          GSCLK|--P4.3
 *      P3.7--|MODE              |
 *      P5.1--|SCLK              |
 *      P3.6--|SIN               |
 *      P5.0--|XLAT              |
 *      P2.3--|BLANK             |
 * Author: 
*******************************************************************************/
/* DriverLib Includes */
#include <ti/devices/msp432p4xx/driverlib/driverlib.h>

/* Standard Includes */
#include <stdint.h>
#include <stdbool.h>
static volatile uint32_t aclk, mclk, smclk, hsmclk, bclk;

#define CPU_F ((double)25000000)

#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))

char DCdata[]={
               30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,//Set Red LED DC D0-D15
               30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,//Set Green LED DC D0-D15
               30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30//Set Blue LED DC D0-D15
               };

char DCdata1[]={
               60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,//Set Red LED DC D0-D15
               60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,//Set Green LED DC D0-D15
               60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60//Set Blue LED DC D0-D15
               };

int GSdata[]={
                0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,//Set Red LED GS D0-D15
                0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,//Set Green LED GS D0-D15
                0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,//Set Blue LED GS D0-D15
};

int color2pwm[]={0,1,1,1,1,1,2,2,2,3,3,3,4,4,4,5,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,14,15,16,17,18,20,
                 21,23,25,26,28,30,32,34,36,38,40,43,45,48,50,53,56,59,62,65,68,71,75,78,82,85,89,93,97,
                 101,105,110,114,119,123,128,133,138,143,149,154,159,165,171,177,183,189,195,202,208,215,
                 222,229,236,243,250,258,266,273,281,290,298,306,315,324,332,341,351,360,369,379,389,399,
                 409,419,430,440,451,462,473,485,496,508,520,532,544,556,569,582,594,608,621,634,648,662,
                 676,690,704,719,734,749,764,779,795,811,827,843,859,876,893,910,927,944,962,980,998,1016,
                 1034,1053,1072,1091,1110,1130,1150,1170,1190,1210,1231,1252,1273,1294,1316,1338,1360,1382,
                 1404,1427,1450,1473,1497,1520,1544,1568,1593,1617,1642,1667,1693,1718,1744,1770,1797,1823,
                 1850,1877,1905,1932,1960,1988,2017,2045,2074,2103,2133,2162,2192,2223,2253,2284,2315,2346,
                 2378,2410,2442,2474,2507,2540,2573,2606,2640,2674,2708,2743,2778,2813,2849,2884,2920,2957,
                 2993,3030,3067,3105,3143,3181,3219,3258,3297,3336,3376,3416,3456,3496,3537,3578,3619,3661,
                 3703,3745,3788,3831,3874,3918,3962,4006,4010,4015};// Gamma table

void SendDCData(char *temp)//Send DC data
{
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN7); //Set MODE High-DC Input Mode

    int k,temp1,temp2;

     for(k=287;k>=0;k--)
       {
         temp1=1<<(k%6);
         temp2=temp[k/6]&temp1;
         if(temp2==temp1)
             {
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);
             }
         else
             {
             GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);
             }
         GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-Low
         __delay_cycles(6);
         GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-high
       }

    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-low



     GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN0);//XLAT-high
     __delay_cycles(6);
     GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN0 ); //XLAT-low
    __delay_cycles(15);

}

void SendGSData(int *temp)// Send Gray Scale data
{
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN7); //Set MODE Low-GS Input Mode

    int k,temp1,temp2;

     for(k=575;k>=0;k--)
       {
         temp1=1<<(k%12);
         temp2=temp[k/12]&temp1;
         if(temp2==temp1)
             {
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);
             }
         else
             {
             GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);
             }
         GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-Low
         __delay_cycles(6);
         GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-high
       }

    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-low

     GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN0);//XLAT-high
     __delay_cycles(6);
     GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN0 ); //XLAT-low
    __delay_cycles(15);

    GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-high
    __delay_cycles(6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1);//SCL-Low

    GPIO_setOutputHighOnPin(GPIO_PORT_P2,GPIO_PIN3);//BLANK-high
    __delay_cycles(3);
     GPIO_setOutputLowOnPin(GPIO_PORT_P2,GPIO_PIN3 ); //BLANK-low
}

void LED_Set(int Num,int GS_Red,int GS_Green,int GS_Blue)
{
    GSdata[Num]=GS_Red;
    GSdata[Num+16]=GS_Green;
    GSdata[Num+32]=GS_Blue;
}

void LED_DC_Set(int Num,int DC_Red,int DC_Green,int DC_Blue)
{
    DCdata[Num]=DC_Red;
    DCdata[Num+16]=DC_Green;
    DCdata[Num+32]=DC_Blue;
}

void Ini_Dark(void)

{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i,0,0,0);
    }
    SendGSData(GSdata);
}

void Ini_Red(void)

{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i,4000,0,0);
    }
    SendGSData(GSdata);
}

void Ini_Green(void)

{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i,0,4000,0);
    }
    SendGSData(GSdata);
}

void Ini_Blue(void)

{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i,0,0,4000);
    }
    SendGSData(GSdata);
}

void Ini_White(void)

{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i,4000,4000,4000);
    }
    SendGSData(GSdata);
}

void breath_fresh_Red(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],0,0);
        }
        SendGSData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],0,0);
        }
        SendGSData(GSdata);
    }
}

void breath_fresh_Green(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,color2pwm[i],0);
        }
        SendGSData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,color2pwm[i],0);
        }
        SendGSData(GSdata);
    }
}

void breath_fresh_Blue(void)
{
    int i=0,j=0;
    for(i=0;i<250;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,0,color2pwm[i]);
        }
        SendGSData(GSdata);
    }

    for(i=249;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,0,color2pwm[i]);
        }
        SendGSData(GSdata);
    }
}

void breath_fresh_Yellow(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],color2pwm[i],0);
        }
        SendGSData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],color2pwm[i],0);
        }
        SendGSData(GSdata);
    }
}

void breath_fresh_Pink(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],0,color2pwm[i]);
        }
        SendGSData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],0,color2pwm[i]);
        }
        SendGSData(GSdata);
    }
}

void breath_fresh_Teal(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,color2pwm[i],color2pwm[i]);
        }
        SendGSData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,color2pwm[i],color2pwm[i]);
        }
        SendGSData(GSdata);
    }
}

void breath_fresh_White(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],color2pwm[i],color2pwm[i]);
        }
        SendGSData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],color2pwm[i],color2pwm[i]);
        }
        SendGSData(GSdata);
    }
}

void breath_fresh_BreathingWithCorlorChanging(void)
{
    int i=0,j=0;
    for(i=0;i<256;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,color2pwm[i],4000);
        }
        SendGSData(GSdata);
    }

    for(i=255;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,0,color2pwm[i],4000);
        }
        SendGSData(GSdata);
    }

    //delay_ms(10);

    for(i=0;i<256;i++)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],0,4000);
        }
        SendGSData(GSdata);
    }

    for(i=255;i>=0;i--)
    {
        for(j=0;j<16;j++)
        {
            LED_Set(j,color2pwm[i],0,4000);
        }
        SendGSData(GSdata);
    }
    delay_ms(10);

}

void ChasingEffect_Red(void)
{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i%16,1034,0,0);
        LED_Set((i+1)%16,1130,0,0);
        LED_Set((i+2)%16,1338,0,0);
        LED_Set((i+3)%16,0,0,0);
        LED_Set((i+4)%16,0,0,0);
        LED_Set((i+5)%16,0,0,0);
        LED_Set((i+6)%16,0,0,0);
        LED_Set((i+7)%16,0,0,0);
        LED_Set((i+8)%16,1034,0,0);
        LED_Set((i+9)%16,1130,0,0);
        LED_Set((i+10)%16,1338,0,0);
        LED_Set((i+11)%16,0,0,0);
        LED_Set((i+12)%16,0,0,0);
        LED_Set((i+13)%16,0,0,0);
        LED_Set((i+14)%16,0,0,0);
        LED_Set((i+15)%16,0,0,0);
        SendGSData(GSdata);
        delay_ms(10);
    }
}

void ChasingEffect_Green(void)
{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i%16,0,1034,0);
        LED_Set((i+1)%16,0,1130,0);
        LED_Set((i+2)%16,0,1338,0);
        LED_Set((i+3)%16,0,0,0);
        LED_Set((i+4)%16,0,0,0);
        LED_Set((i+5)%16,0,0,0);
        LED_Set((i+6)%16,0,0,0);
        LED_Set((i+7)%16,0,0,0);
        LED_Set((i+8)%16,0,1034,0);
        LED_Set((i+9)%16,0,1130,0);
        LED_Set((i+10)%16,0,1338,0);
        LED_Set((i+11)%16,0,0,0);
        LED_Set((i+12)%16,0,0,0);
        LED_Set((i+13)%16,0,0,0);
        LED_Set((i+14)%16,0,0,0);
        LED_Set((i+15)%16,0,0,0);
        SendGSData(GSdata);
        delay_ms(10);
    }
}

void ChasingEffect_Blue(void)
{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i%16,0,0,1034);
        LED_Set((i+1)%16,0,0,1130);
        LED_Set((i+2)%16,0,0,1338);
        LED_Set((i+3)%16,0,0,0);
        LED_Set((i+4)%16,0,0,0);
        LED_Set((i+5)%16,0,0,0);
        LED_Set((i+6)%16,0,0,0);
        LED_Set((i+7)%16,0,0,0);
        LED_Set((i+8)%16,0,0,1034);
        LED_Set((i+9)%16,0,0,1130);
        LED_Set((i+10)%16,0,0,1338);
        LED_Set((i+11)%16,0,0,0);
        LED_Set((i+12)%16,0,0,0);
        LED_Set((i+13)%16,0,0,0);
        LED_Set((i+14)%16,0,0,0);
        LED_Set((i+15)%16,0,0,0);
        SendGSData(GSdata);
        delay_ms(10);
    }
}

void ChasingEffect_Custom(void)
{
    int i;
    for(i=0;i<16;i++)
    {
        LED_Set(i%16,1034,1034,0);
        LED_Set((i+1)%16,1130,1130,0);
        LED_Set((i+2)%16,1338,1338,0);
        LED_Set((i+3)%16,0,0,2000);
        LED_Set((i+4)%16,0,0,2000);
        LED_Set((i+5)%16,0,0,2000);
        LED_Set((i+6)%16,0,0,2000);
        LED_Set((i+7)%16,0,0,2000);
        LED_Set((i+8)%16,1034,512,256);
        LED_Set((i+9)%16,2048,1024,512);
        LED_Set((i+10)%16,4095,2048,1024);
        LED_Set((i+11)%16,0,0,2000);
        LED_Set((i+12)%16,0,0,2000);
        LED_Set((i+13)%16,0,0,2000);
        LED_Set((i+14)%16,0,0,2000);
        LED_Set((i+15)%16,0,0,2000);
        SendGSData(GSdata);
        delay_ms(10);
    }
}

void ChasingEffect_Wait(void)
{
    int i,j;
/*    for(j=0;j<16;j++)
    {
        for(i=0;i<j;i++)
        {
            LED_Set(i,100*(16-j+i)+10,90*(16-j+i)+4,80*(16-j+i)+3);
        }
        for(i=j;i<16;i++)
        {
            LED_Set(i,100*(i-j)+5,90*(i-j)+4,80*(i-j)+3);
        }
        SendGSData(GSdata);
        delay_ms(30);
    }*/
    for(j=0;j<16;j++)
    {
        for(i=0;i<16;i++)
        {
            LED_Set((i+j)%16,color2pwm[10*i]+5,color2pwm[10*i]+5,color2pwm[10*i]+5);
        }
        SendGSData(GSdata);
        delay_ms(10);
    }
    /*for(i=0;i<16;i++)
    {
        LED_Set(i%16,1034,1034,2034);
        LED_Set((i+1)%16,1034,1034,2034);
        LED_Set((i+2)%16,1034,1034,2034);
        LED_Set((i+3)%16,1034,1034,2034);
        LED_Set((i+4)%16,1034,1034,2034);
        LED_Set((i+5)%16,1034,1034,2034);
        LED_Set((i+6)%16,1034,1034,2034);
        LED_Set((i+7)%16,1034,1034,2034);
        LED_Set((i+8)%16,100,100,200);
        LED_Set((i+9)%16,100,100,200);
        LED_Set((i+10)%16,100,100,200);
        LED_Set((i+11)%16,100,100,200);
        LED_Set((i+12)%16,100,100,200);
        LED_Set((i+13)%16,100,100,200);
        LED_Set((i+14)%16,100,100,200);
        LED_Set((i+15)%16,100,100,200);
        SendGSData(GSdata);
        delay_ms(10);
    }*/
}

int main(void)

{
    MAP_WDT_A_holdTimer();
    /* Setting the DCO Frequency to a non-standard 8.33MHz */
   // MAP_CS_setDCOFrequency(8330000);

    /* Initializing the clock source as follows:
     *      MCLK = MODOSC/4 = 6MHz
     *      ACLK = REFO/2 = 16kHz
     *      HSMCLK = DCO/2 = 1.5Mhz
     *      SMCLK = DCO/4 = 750kHz
     *      BCLK  = REFO = 32kHz
     */
    MAP_CS_initClockSignal(CS_MCLK, CS_MODOSC_SELECT, CS_CLOCK_DIVIDER_2);  //MODOSC:Internal low-power oscillator with 25-MHz typical frequency
    MAP_CS_initClockSignal(CS_ACLK, CS_REFOCLK_SELECT, CS_CLOCK_DIVIDER_2);
    MAP_CS_initClockSignal(CS_HSMCLK, CS_DCOCLK_SELECT, CS_CLOCK_DIVIDER_2);
    MAP_CS_initClockSignal(CS_SMCLK, CS_DCOCLK_SELECT, CS_CLOCK_DIVIDER_4);
    MAP_CS_initClockSignal(CS_BCLK, CS_REFOCLK_SELECT, CS_CLOCK_DIVIDER_1);
    /*
     *  Getting all of the frequency values of the CLK sources using the
     * convenience functions */
    aclk = CS_getACLK();
    mclk = CS_getMCLK();
    smclk = CS_getSMCLK();
    hsmclk = CS_getHSMCLK();
    bclk = CS_getBCLK();

    GPIO_setAsOutputPin(GPIO_PORT_P3, GPIO_PIN6|GPIO_PIN7);
    GPIO_setAsOutputPin(GPIO_PORT_P2, GPIO_PIN3);
    GPIO_setAsOutputPin(GPIO_PORT_P5, GPIO_PIN0|GPIO_PIN1);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3, GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN0|GPIO_PIN1);
    GPIO_setAsPeripheralModuleFunctionOutputPin(GPIO_PORT_P4,GPIO_PIN3,GPIO_PRIMARY_MODULE_FUNCTION);

    SendDCData(DCdata1);
    //SendDCData(DCdata);
    //Ini_White();
 while(1)
    {

       breath_fresh_Red();

       breath_fresh_Green();

       breath_fresh_Blue();

       breath_fresh_Yellow();

       breath_fresh_Pink();

       breath_fresh_Teal();

       breath_fresh_White();

       breath_fresh_BreathingWithCorlorChanging();

       ChasingEffect_Red();

       ChasingEffect_Green();

       ChasingEffect_Blue();

       ChasingEffect_Custom();

       ChasingEffect_Wait();

    }
}


